/*
 * pi - P user Interface
 * 
 * $Id: progressbar.c,v 1.1 2001/02/05 15:51:07 malekith Exp $
 * Author: Michal Moskal <malekith@pld.org.pl>
 * include COPYING-GNU
 */

#include <pi/pi.h>
#include <string.h>

int pi_progressbar_need_update(struct pi_object *ctx)
{
	int w, pos, cnt;

	w = pi_intd(cache1, -1);
	pos = pi_intd(cache2, -1);
	cnt = pi_int(max) - pi_int(min);
	if (cnt == 0)
		cnt++;
	cnt = (long long)(pi_int(pos) - pi_int(min)) * ctx->w / cnt;
	if (cnt > ctx->w)
		cnt = ctx->w;
	if (cnt < 0)
		cnt = 0;
	if (ctx->w == w && pos == cnt)
		return 0;

	pi_set_tag(ctx, pi_tag_cache1, ctx->w);
	pi_set_tag(ctx, pi_tag_cache2, cnt);

	return 1;
}

void pi_progressbar_draw(struct pi_object *ctx)
{
	int k, n;
	
	pi_progressbar_need_update(ctx);
	n = pi_int(cache2);
	k = ctx->w - n;
		
	pi_locate(ctx, 0, 0);
	pi_set_color(ctx, 1);
	while (n--)
		pi_putch('#');
	pi_set_color(ctx, 0);
	while (k--)
		pi_putch(':');
}

struct pi_object *pi_new_progressbar(struct pi_object *ctx, struct pi_object *super)
{
	pi_new_init((0,
			pi_tag_flags, 0,
			pi_tag_draw_handler, pi_progressbar_draw,
			pi_tag_max, 100,
			pi_tag_min, 0,
			pi_tag_pos, 50,
			PI_COLOR(norm_hl, cyan, cyan),
			PI_COLOR(norm, blue, blue),
	0), object);

	pi_copy_int(min);
	pi_copy_int(max);
	pi_copy_int(pos);

	pi_init_size(ret, 0, 0, 50, 1);

	return ret;
}
