/*
  $Id: log.h,v 1.2 2001/01/29 12:29:19 malekith Exp $
*/

#ifndef __LOG_H
#define __LOG_H

#if USE_CONFIG_H
# include "config.h"
#else
# define LOGDEBUGSCR_ENV "LOG_DEBUG_TO_SCREEN"
# define LOGDEBUG_ENV "LOG_DEBUG"
#endif
    

int log_openlog(const char *pathname);
void log_closelog(void);

#define log_open(a) log_openlog(a)
#define log_close() log_closelog()
    
/*Use those 2 functions like printf(...) */    
void log_message(const char *fmt, ...);

/*
1) If env variable LOG_DEBUG is set
   logs messages with prefix "DEBUG: "
                                        
2) If 1) && env variable LOG_DEBUG_TO_SCREEN is
   set, puts messages on stderr OR
   if callback func is set, run it.
   This can be useful with GUIs
*/    
void do_log_debug_message(char *fmt, ...);


#define log_debug_message(fmt, args...) \
  do_log_debug_message("%s: " fmt, __FUNCTION__ , ## args)


#define log_debug log_debug_message

/* sets callback, callback prototype is similar to printf:
   void f (const char* fmt, ...)
*/    
void log_set_callback(void (*msgfunc)(const char *, ...));

#endif
