DROP VIEW report_count;
DROP TABLE package_feature;
DROP TABLE enviroment;
DROP TABLE comment;
DROP TABLE opinion ;
DROP TABLE report;
DROP TABLE arch;
DROP TABLE feature;
DROP TABLE machine;

DROP SEQUENCE machine_id_seq;
DROP SEQUENCE feature_id_seq;
DROP SEQUENCE arch_id_seq;
DROP SEQUENCE report_id_seq;
DROP SEQUENCE opinion_id_seq;
DROP SEQUENCE comment_id_seq;


-- to jest w mbt
--CREATE TABLE person(
--	id serial PRIMARY KEY,
--	nick text,
--	firstname text,
--	surname text,
--	email text,
--	password text
--);

CREATE TABLE machine(
	id	SERIAL PRIMARY KEY,
	person_id INTEGER REFERENCES person ON DELETE CASCADE,
	name	varchar(30)
);

CREATE TABLE feature(
	id serial PRIMARY KEY,
	name text,
	approved integer,
	author integer 
);


INSERT INTO feature(name) VALUES('Genereally works');
INSERT INTO feature(name) VALUES('Upgrade from earlier version works');

-- to jest w mbt
--CREATE TABLE package(
--	id serial PRIMARY KEY,
--	name text
--);
--create unique index package_name_idx on package(name);

CREATE TABLE arch(
	id serial PRIMARY KEY,
	name text
);

CREATE TABLE report(
	id serial PRIMARY KEY,
	id_machine integer REFERENCES machine ON DELETE CASCADE,
	id_package integer REFERENCES package ON DELETE CASCADE,
	id_arch integer REFERENCES arch ON DELETE CASCADE ,
	EVR text,
	date date
);
	
CREATE TABLE opinion (
	id serial PRIMARY KEY,
	id_report integer REFERENCES report ON DELETE CASCADE,
	id_feature integer REFERENCES feature ON DELETE CASCADE,
	mark integer
);

CREATE TABLE COMMENT(
	id serial PRIMARY KEY,
	id_opinion integer REFERENCES opinion ON DELETE CASCADE,
	comment text
);

CREATE TABLE enviroment(
	id_report integer REFERENCES report ON DELETE CASCADE,
	id_package integer REFERENCES package ON DELETE CASCADE, 
	EVR text,
	id_arch integer REFERENCES arch ON DELETE CASCADE 
);

CREATE TABLE package_feature(
	id_package	integer REFERENCES package ON DELETE CASCADE ,
	id_feature	integer REFERENCES feature ON DELETE CASCADE,
	approved	integer REFERENCES feature ON DELETE CASCADE,
	author		integer REFERENCES feature ON DELETE CASCADE,
	primary key (id_package, id_feature)
);

-- zamiast tego uzywane sa pkg_evr_dist i dist z mbt
--CREATE TABLE in_test(
--	id_package INTEGER,
--	evr text
--);

CREATE VIEW report_count as SELECT count(report.id) AS count, report.evr, report.id_package FROM report GROUP BY report.evr, report.id_package;
-- CREATE TABLE tmp_rep(
--	id int;
-- );
